using GMW_data;
using SteamWare;
using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace GMW.WebUserControls
{
    public partial class mod_delibera : SteamWare.ApplicationUserControl
    {
        #region area da NON modificare

        #region area protected

        protected string _idxGridView;
        protected string _idxGridViewExt;
        protected string _tabCache;

        /// <summary>
        /// aggiorna controlli datagrid e numero righe in pagina
        /// </summary>
        protected override void aggiornaControlliDataGL()
        {
            base.aggiornaControlliDataGL();
            grView.PageSize = _righeDataGridMed;
        }
        /// <summary>
        /// traduce gli header delle colonne
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void grView_DataBound(object sender, EventArgs e)
        {
            if (grView.Rows.Count > 0)
            {
                LinkButton lb;
                // aggiorno gli headers        
                foreach (TableCell cella in grView.HeaderRow.Cells)
                {
                    try
                    {
                        lb = (LinkButton)cella.Controls[0];
                        lb.Text = traduci(lb.Text);
                    }
                    catch
                    { }
                }
                int totRecord = grView.Rows.Count + grView.PageSize * (grView.PageCount - 1);
                lblNumRec.Text = string.Format("{0} records of ~ {1}", grView.Rows.Count, totRecord);
            }
            else
            {
                lblNumRec.Text = "";
            }
        }
        /// <summary>
        /// reset della selezione
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnReset_Click(object sender, EventArgs e)
        {
            resetSelezione();
        }


        /// <summary>
        /// collega i controlli
        /// </summary>
        protected override void bindControlli()
        {
            base.bindControlli();
            caricaTabelle();
        }

        #endregion

        #region gestione eventi

        public event EventHandler eh_resetSelezione;
        //public event EventHandler eh_nuovoValore;
        //public event EventHandler eh_selValore;

        #endregion

        #region public

        /// <summary>
        /// effettua update del modulo
        /// </summary>
        public void doUpdate()
        {
            resetSelezione();
        }


        #endregion

        #endregion

        #region area codice variabile

        /// <summary>
        /// carico le tabelle
        /// </summary>
        private void caricaTabelle()
        {
        }
        /// <summary>
        /// elenco colonne del datagrid
        /// </summary>
        /// <returns></returns>
        protected DataColumnCollection colonneObj()
        {
            DS_magazzino.V_MagazziniOverviewDataTable tabella = new DS_magazzino.V_MagazziniOverviewDataTable();
            DataColumnCollection colonne = tabella.Columns;
            return colonne;
        }
        /// <summary>
        /// inizializzazione valori di default
        /// </summary>
        /// <param name="e"></param>
        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            _idxGridView = "UDC";
            mod_filtroDelibera.eh_selValore += new EventHandler(mod_filtroDelibera_eh_selValore);
            if (!Page.IsPostBack)
            {
                btnDelibera.Text = traduci("btnDelibera");
                cbeBtnDelibera.ConfirmText = traduci("cbeBtnDelibera");
                mod_detailUDC1.Visible = false;
                mod_filtroDelibera.ods = odsFiltroDelibera;
                // imposto corretto valore x filtro                 
                if (memLayer.ML.isInSessionObject("CodTipoDelib_sel"))
                {
                    mod_filtroDelibera.valore = memLayer.ML.StringSessionObj("CodTipoDelib_sel");
                }
                else
                {
                    mod_filtroDelibera.reset();
                }
                checkFixOds();
            }
        }
        /// <summary>
        /// fix tipo delibera
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        void mod_filtroDelibera_eh_selValore(object sender, EventArgs e)
        {
            // chiamo procedura che aggiorna ods principale
            checkFixOds();
        }
        /// <summary>
        /// segnalo nuovo valore filtro attivo...
        /// </summary>
        private void checkFixOds()
        {
#if false
            // determino cosa filtrare nella filter expression...
            if (mod_filtroDelibera.valore != "*")
            {
                ods.FilterExpression = string.Format(" CodMag = '{0}' ", mod_filtroDelibera.valore);
                // salvo il valore del numero di celle max x poter scalare correttamente i barplot
                try
                {
                    maxNumCelle = MagClass.magazzino.taMagOverw.getMaxCelleByMag(memLayer.ML.StringSessionObj("CodCS"), mod_filtroDelibera.valore)[0].TotCelle;
                }
                catch
                {
                    maxNumCelle = 1;
                }
            }
            else
            {
                ods.FilterExpression = "";
                // salvo il valore del numero di celle max x poter scalare correttamente i barplot
                try
                {
                    maxNumCelle = MagClass.magazzino.taMagOverw.getMaxCelle(memLayer.ML.StringSessionObj("CodCS"))[0].TotCelle;
                }
                catch
                {
                    maxNumCelle = 1;
                }
            }
            grView.DataBind(); 
#endif
        }
        /// <summary>
        /// aggiorno visualizzazione
        /// </summary>
        private void updateOdsDaFiltro()
        {
            grView.DataBind();
        }
        /// <summary>
        /// chiamata post page change gridview
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void grView_PageIndexChanged(object sender, EventArgs e)
        {
            // sistemazione dell'ods post evento cambio pagina
            checkFixOds();
        }
        /// <summary>
        /// chiamata post sort gridview
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void grView_Sorted(object sender, EventArgs e)
        {
            // sistemazione dell'ods post evento sort
            checkFixOds();
        }
        /// <summary>
        /// gestione cambio selezione valore
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void grView_SelectedIndexChanged(object sender, EventArgs e)
        {
            // salvo in session il valore selezionato...
            SteamWare.memLayer.ML.setSessionVal(string.Format("{0}_sel", _idxGridView), grView.SelectedValue, true);

            mod_detailUDC1.Visible = true;
            mod_detailUDC1.doUpdate();

            //// sollevo evento nuovo valore...
            //if (eh_selValore != null)
            //{
            //    eh_selValore(this, new EventArgs());
            //} 
        }
        /// <summary>
        /// seleziona/deseleziona le righe indicate...
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnSelAll_Click(object sender, EventArgs e)
        {
            // seleziono tutti i valori visibili nel datagrid
            CheckBox chkbox = ((CheckBox)sender);
            bool isChecked = chkbox.Checked;
            if (!isChecked)
            {
                chkbox.ToolTip = traduci("btnSelAll");
            }
            else
            {
                chkbox.ToolTip = traduci("btnDeselAll");
            }
            foreach (GridViewRow riga in grView.Rows)
            {
                ((CheckBox)riga.FindControl("chkSelect")).Checked = isChecked;
            }
        }
        /// <summary>
        /// resetta la selezione dei valori in caso di modifiche su altri controlli
        /// </summary>
        public void resetSelezione()
        {
            mod_detailUDC1.Visible = false;
            SteamWare.memLayer.ML.emptySessionVal(string.Format("{0}_sel", _idxGridView));
            grView.SelectedIndex = -1;
            grView.DataBind();
            lblWarning.Visible = false;
            if (eh_resetSelezione != null)
            {
                eh_resetSelezione(this, new EventArgs());
            }
        }
        /// <summary>
        /// effettua delibera per gli UDC selezionati
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void btnDelibera_Click(object sender, EventArgs e)
        {
            DateTime start;
            foreach (GridViewRow riga in grView.Rows)
            {
                if (((CheckBox)riga.FindControl("chkSelect")).Checked && ((CheckBox)riga.FindControl("chkSelect")).Visible)
                {
                    start = DateTime.Now;
                    // recupero codice UDC...
                    string UDC = ((Label)riga.FindControl("lblUDC")).Text;
                    // chiamo stored x fare delibera con state machine
                    string CodEvento = mod_filtroDelibera.valore;
                    try
                    {
                        CodEvento = StateMachine.SM.taATD.getByKey(mod_filtroDelibera.valore)[0].CodEvento;
                    }
                    catch
                    { }
                    StateMachine.SM.deliberaUdc(UDC, mod_filtroDelibera.valore, CodEvento, Request.UserHostName);
                }
            }
            grView.DataBind();
        }

        #endregion

    }
}